/*
 *  Copyright 2016 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.forms.buttons');

org.ametys.forms.buttons.ClearFormEntriesButton = function(id, configuration, pluginName) 
{
	org.ametys.forms.buttons.ClearFormEntriesButton.superclass.constructor.call(this, id, configuration, pluginName);
};

Ext.extend(org.ametys.forms.buttons.ClearFormEntriesButton, org.ametys.ribbon.control.button.ActionSelectionButton, {});

org.ametys.forms.buttons.ClearFormEntriesButton.prototype.onMessage = function (messages)
{
	for (var i=messages.length - 1; i >= 0; i--)
	{
		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
		{
			var targets = messages[i].getTargets();
			var allContentFormTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, this.checkTarget());
			
			// No content selected
			if (allContentFormTargets.length == 0)
			{
				this.getElements().each(function(element) { element.setDisabled(true); });
				this.updateTooltip(this.getConfiguration()["default-description"]);
			}
			else
			{
				for (var j=0; j < allContentFormTargets.length; j++)
				{
					var hasEntries = false;
					var contentFormTarget = allContentFormTargets[j];
					if (contentFormTarget.getParameters().hasEntries === true)
					{
						hasEntries = true;
						break;
					}
				}
				
				this.getElements().each(function(element) { element.setDisabled(!hasEntries); });
				
				var tooltip = this.getConfiguration()["default-description"];
				if (!hasEntries)
				{
					tooltip = this.getConfiguration()["no-entries-description"]
				}
				
				this.updateTooltip(tooltip);
				
				return;
			}
		}
	}
}

org.ametys.forms.buttons.ClearFormEntriesButton.prototype.checkTarget = function ()
{
	return function (target) { return target.getType() == 'content-form'; };
}

